diff --git a/test/unit/daemon/stale_agent_healer_probe_retry_test.rb b/test/unit/daemon/stale_agent_healer_probe_retry_test.rb
new file mode 100644
index 000000000..ae4043e49
--- /dev/null
+++ b/test/unit/daemon/stale_agent_healer_probe_retry_test.rb
@@ -0,0 +1,570 @@
+require "test_helper"
+require "tmpdir"
+require "time"
+require "hive/markers"
+require "hive/daemon/health_probe"
+require "hive/daemon/health_signals"
+require "hive/daemon/stale_agent_healer"
+require "hive/daemon/status_consumer"
+
+# Probe-gated auto-retry of the two v1 recoverable terminal-error markers.
+# The healer must clear `implementer_failed` (Codex 401) and
+# `claude_launch_failed` ONLY when the universal + reason probes pass, the
+# health fingerprint changed (or a fallback elapsed), the work area is safe,
+# and the stricter retry budget (2) with backoff is respected.
+class HiveDaemonStaleAgentHealerProbeRetryTest < Minitest::Test
+  include HiveTestHelper
+
+  Row = Hive::Daemon::StatusConsumer::Row
+  Result = Hive::Daemon::HealthProbe::Result
+
+  HEADLESS_CFG = { "claude" => { "mode" => "headless" } }.freeze
+
+  class FakeController
+    attr_reader :observed_mtimes
+
+    def initialize(running_pairs: [])
+      @running = running_pairs
+      @observed_mtimes = []
+    end
+
+    def running_task?(project:, slug:)
+      @running.include?([ project, slug ])
+    end
+
+    def observe_state_file_mtime(project:, slug:, mtime:)
+      @observed_mtimes << { project: project, slug: slug, mtime: mtime }
+    end
+  end
+
+  class FakeLogger
+    attr_reader :events
+
+    def initialize
+      @events = []
+    end
+
+    def event(name, **attrs)
+      @events << [ name, attrs ]
+    end
+  end
+
+  class FakeRequestQueue
+    attr_reader :requests
+
+    def initialize
+      @requests = []
+    end
+
+    def write_request!(**kwargs)
+      @requests << kwargs
+      "fake-req-#{@requests.size}"
+    end
+  end
+
+  class FakeProbe
+    attr_accessor :universal, :codex, :claude
+    attr_reader :calls, :last_claude_universal
+
+    def initialize
+      @calls = []
+      @universal = Result.new(name: "universal", healthy: true, status: "healthy", detail: "ok")
+      @codex = Result.new(name: "codex_auth", healthy: true, status: "healthy", detail: "ok")
+      @claude = Result.new(name: "claude_launcher", healthy: true, status: "healthy", detail: "ok")
+    end
+
+    def probe_universal(config: nil, project_root: nil, stage: nil)
+      @calls << :universal
+      @universal
+    end
+
+    def probe_codex_auth(env: nil)
+      @calls << :codex
+      @codex
+    end
+
+    def probe_claude_launcher(config: nil, project_root: nil, env: nil, wrapper_path: nil, code_fingerprint: nil, stage: nil, universal_result: nil)
+      @calls << :claude
+      @last_claude_universal = universal_result
+      @claude
+    end
+  end
+
+  NOW = Time.utc(2026, 7, 1, 12, 0, 0)
+
+  def setup
+    @logger = FakeLogger.new
+    @controller = FakeController.new
+    @request_queue = FakeRequestQueue.new
+    @probe = FakeProbe.new
+  end
+
+  # `worktree_clean:` stubs the real worktree predicate so most tests can
+  # focus on the probe/budget/safety wiring; pass `:real` to exercise the
+  # actual git-porcelain predicate.
+  def build_healer(auto_retry_enabled: true, probe: @probe, signal_cache: nil, env: {}, worktree_clean: true, project_config_resolver: ->(_name) { [ HEADLESS_CFG, nil ] })
+    healer = Hive::Daemon::StaleAgentHealer.new(
+      controller: @controller,
+      logger: @logger,
+      grace_sec: 300,
+      request_queue: @request_queue,
+      probe: probe,
+      signal_cache: signal_cache || Hive::Daemon::HealthSignalCache.new,
+      auto_retry_enabled: auto_retry_enabled,
+      project_config_resolver: project_config_resolver,
+      env: env
+    )
+    healer.define_singleton_method(:worktree_clean?, ->(_row) { worktree_clean }) unless worktree_clean == :real
+    healer
+  end
+
+  def with_marker_file(reason:, message:, stage: "4-execute", marker_id: "err-a")
+    Dir.mktmpdir do |dir|
+      state_file = File.join(dir, "task.md")
+      attrs = "reason=#{reason} marker_id=#{marker_id}"
+      attrs += " message=\"#{message}\"" if message
+      File.write(state_file, "# task\n\n<!-- ERROR #{attrs} -->\n")
+      yield state_file, dir
+    end
+  end
+
+  def make_row(state_file, reason:, message:, stage: "4-execute", marker_id: "err-a", folder: nil, mtime: NOW - 1000, live_task_lock: false)
+    attrs = { "reason" => reason, "marker_id" => marker_id }
+    attrs["message"] = message if message
+    Row.new(
+      project: "p", slug: "s", stage: stage, workflow: nil,
+      marker: "error", marker_attrs: attrs,
+      folder: folder || File.dirname(state_file), state_file: state_file,
+      state_file_mtime: mtime, action: "error", suggested_command: nil,
+      claude_pid_alive: nil, live_task_lock: live_task_lock, diagnostic: nil
+    )
+  end
+
+  def heal(rows, now: NOW)
+    build_healer.heal(rows, now: now)
+  end
+
+  # ── happy paths ────────────────────────────────────────────────────────
+
+  def test_codex_auth_failure_clears_and_emits_auto_retry
+    with_marker_file(reason: "implementer_failed", message: "401 Missing bearer/basic auth") do |state_file, dir|
+      row = make_row(state_file, reason: "implementer_failed", message: "401 Missing bearer/basic auth")
+      heal([ row ])
+
+      assert Hive::Markers.current(state_file).none?, "the Codex-401 marker must clear"
+      healed = @logger.events.find { |name, _| name == :marker_healed }
+      assert healed, "expected marker_healed, got: #{@logger.events.inspect}"
+      assert_equal "codex_auth_recovered", healed[1][:reason]
+      assert_equal "implementer_failed", healed[1][:marker_reason]
+      assert_equal 1, healed[1][:attempts]
+
+      events_line = File.read(File.join(dir, "events.jsonl"))
+      assert_includes events_line, "\"event_type\":\"auto_retry\""
+      assert_includes events_line, "implementer_failed"
+    end
+  end
+
+  def test_claude_launch_failed_clears_when_probes_green
+    with_marker_file(reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") do |state_file, _dir|
+      row = make_row(state_file, reason: "claude_launch_failed", message: "claude interactive prompt did not become ready")
+      heal([ row ])
+
+      assert Hive::Markers.current(state_file).none?
+      healed = @logger.events.find { |name, _| name == :marker_healed }
+      assert healed
+      assert_equal "claude_launcher_recovered", healed[1][:reason]
+    end
+  end
+
+  def test_claude_probe_cycle_runs_universal_probe_once_and_reuses_result
+    with_marker_file(reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") do |state_file, _dir|
+      row = make_row(state_file, reason: "claude_launch_failed", message: "claude interactive prompt did not become ready")
+      heal([ row ])
+
+      assert_equal 1, @probe.calls.count(:universal),
+                   "the universal doctor probe must run once per claude probe cycle"
+      assert_equal 1, @probe.calls.count(:claude)
+      assert @probe.last_claude_universal, "claude probe must receive the precomputed universal result"
+      assert @probe.last_claude_universal.healthy?
+    end
+  end
+
+  def test_plan_probe_gated_recovery_requeues_plan_rerun
+    Dir.mktmpdir do |dir|
+      state_file = File.join(dir, "plan.md")
+      File.write(state_file, <<~MD)
+        # Plan
+
+        ## Overview
+        something
+
+        <!-- ERROR reason=claude_launch_failed marker_id=err-a -->
+      MD
+      row = make_row(state_file, reason: "claude_launch_failed", message: "x", stage: "3-plan", folder: dir)
+      build_healer.heal([ row ], now: NOW)
+
+      assert Hive::Markers.current(state_file).none?, "a probe-gated 3-plan error must clear"
+      request = @request_queue.requests.find do |req|
+        req[:argv] == [ "hive", "plan", "s", "--project", "p", "--from", "3-plan" ]
+      end
+      assert request,
+             "3-plan recovery must enqueue an explicit plan rerun, got: #{@request_queue.requests.inspect}"
+      assert_equal "healer", request[:requestor]
+    end
+  end
+
+  # ── classifier gating ──────────────────────────────────────────────────
+
+  def test_unknown_implementer_failed_stays_parked
+    with_marker_file(reason: "implementer_failed", message: "exit_code=1") do |state_file, _dir|
+      row = make_row(state_file, reason: "implementer_failed", message: "exit_code=1")
+      heal([ row ])
+
+      refute @logger.events.any? { |name, _| name == :marker_healed },
+             "an implementer_failed without a Codex-401 signature must stay parked"
+      assert_match(/ERROR/, File.read(state_file))
+    end
+  end
+
+  def test_other_reasons_never_enter_probe_path
+    with_marker_file(reason: "git_status_failed", message: "boom") do |state_file, _dir|
+      row = make_row(state_file, reason: "git_status_failed", message: "boom")
+      heal([ row ])
+
+      assert_empty @probe.calls, "non-recoverable reasons must not trigger probes"
+      assert_match(/ERROR reason=git_status_failed/, File.read(state_file))
+    end
+  end
+
+  # ── probe health gating ────────────────────────────────────────────────
+
+  def test_probe_not_healthy_blocks_retry_with_negative_event
+    @probe.codex = Result.new(name: "codex_auth", healthy: false, status: "unhealthy", detail: "smoke test failed")
+    with_marker_file(reason: "implementer_failed", message: "401 Missing bearer/basic auth") do |state_file, _dir|
+      row = make_row(state_file, reason: "implementer_failed", message: "401 Missing bearer/basic auth")
+      heal([ row ])
+
+      refute @logger.events.any? { |name, _| name == :marker_healed }
+      blocked = @logger.events.find { |name, _| name == :auto_retry_blocked }
+      assert blocked, "expected auto_retry_blocked, got: #{@logger.events.inspect}"
+      assert_equal "probe not healthy", blocked[1][:rationale]
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+    end
+  end
+
+  # ── work area safety ───────────────────────────────────────────────────
+
+  def test_dirty_worktree_blocks_retry
+    healer = build_healer(worktree_clean: false)
+    with_marker_file(reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") do |state_file, _dir|
+      row = make_row(state_file, reason: "claude_launch_failed", message: "claude interactive prompt did not become ready")
+      healer.heal([ row ], now: NOW)
+
+      refute @logger.events.any? { |name, _| name == :marker_healed }
+      blocked = @logger.events.find { |name, _| name == :auto_retry_blocked }
+      assert blocked
+      assert_equal "unsafe work area", blocked[1][:rationale]
+      assert_match(/ERROR reason=claude_launch_failed/, File.read(state_file))
+    end
+  end
+
+  def test_safe_to_retry_true_for_non_worktree_stages
+    healer = build_healer(worktree_clean: :real)
+    row = make_row("/tmp/missing.md", reason: "claude_launch_failed", message: "x", stage: "3-plan")
+    assert healer.send(:safe_to_retry?, row)
+  end
+
+  # ── answered-content safety (brainstorm/plan) ────────────────────────
+
+  def test_brainstorm_with_answered_content_blocks_retry
+    healer = build_healer(worktree_clean: :real)
+    Dir.mktmpdir do |dir|
+      state_file = File.join(dir, "brainstorm.md")
+      File.write(state_file, <<~MD)
+        ## Round 1
+        ### Q1. What is the scope?
+        ### A1.
+        Build a CLI.
+
+        <!-- ERROR reason=claude_launch_failed marker_id=err-a -->
+      MD
+      row = make_row(state_file, reason: "claude_launch_failed", message: "x", stage: "2-brainstorm", folder: dir)
+      healer.heal([ row ], now: NOW)
+
+      refute @logger.events.any? { |name, _| name == :marker_healed },
+             "a brainstorm with answered content must never be auto-cleared"
+      blocked = @logger.events.find { |name, _| name == :auto_retry_blocked }
+      assert blocked, "expected auto_retry_blocked, got: #{@logger.events.inspect}"
+      assert_equal "unsafe work area", blocked[1][:rationale]
+      assert_match(/ERROR reason=claude_launch_failed/, File.read(state_file))
+    end
+  end
+
+  def test_brainstorm_without_answers_is_safe_to_retry
+    healer = build_healer(worktree_clean: :real)
+    Dir.mktmpdir do |dir|
+      state_file = File.join(dir, "brainstorm.md")
+      File.write(state_file, <<~MD)
+        ## Round 1
+        ### Q1. What is the scope?
+        ### A1.
+
+        <!-- ERROR reason=claude_launch_failed marker_id=err-a -->
+      MD
+      row = make_row(state_file, reason: "claude_launch_failed", message: "x", stage: "2-brainstorm", folder: dir)
+      healer.heal([ row ], now: NOW)
+
+      assert Hive::Markers.current(state_file).none?, "an answer-free brainstorm must clear"
+    end
+  end
+
+  def test_plan_with_waiting_marker_blocks_retry
+    healer = build_healer(worktree_clean: :real)
+    Dir.mktmpdir do |dir|
+      state_file = File.join(dir, "plan.md")
+      File.write(state_file, <<~MD)
+        # Plan
+
+        ## Overview
+        something
+
+        <!-- WAITING -->
+        <!-- ERROR reason=claude_launch_failed marker_id=err-a -->
+      MD
+      row = make_row(state_file, reason: "claude_launch_failed", message: "x", stage: "3-plan", folder: dir)
+      healer.heal([ row ], now: NOW)
+
+      refute @logger.events.any? { |name, _| name == :marker_healed },
+             "a plan with an in-flight WAITING answer must never be auto-cleared"
+      blocked = @logger.events.find { |name, _| name == :auto_retry_blocked }
+      assert_equal "unsafe work area", blocked[1][:rationale]
+    end
+  end
+
+  # ── real worktree predicate ───────────────────────────────────────────
+
+  def test_worktree_clean_uses_git_porcelain
+    with_tmp_git_repo do |repo|
+      Dir.mktmpdir do |folder_dir|
+        File.write(File.join(folder_dir, "worktree.yml"), { "path" => repo }.to_yaml)
+        row = make_row(File.join(folder_dir, "task.md"), reason: "claude_launch_failed", message: "x", folder: folder_dir)
+        healer = build_healer(worktree_clean: :real)
+        assert healer.send(:worktree_clean?, row), "a clean git worktree must pass the safety gate"
+        assert healer.send(:safe_to_retry?, row)
+
+        File.write(File.join(repo, "dirty.txt"), "residue")
+        refute healer.send(:worktree_clean?, row), "a dirty worktree must fail the safety gate"
+      end
+    end
+  end
+
+  def test_worktree_clean_false_without_pointer
+    healer = build_healer(worktree_clean: :real)
+    row = make_row("/tmp/missing.md", reason: "claude_launch_failed", message: "x")
+    refute healer.send(:worktree_clean?, row)
+    refute healer.send(:safe_to_retry?, row)
+  end
+
+  # ── retry budget / backoff ─────────────────────────────────────────────
+
+  def test_third_failure_exhausts_budget
+    healer = build_healer
+    with_marker_file(reason: "implementer_failed", message: "401 Missing bearer/basic auth") do |state_file, _dir|
+      # Attempt 1 (immediate)
+      healer.heal([ make_row(state_file, reason: "implementer_failed", message: "401 Missing bearer/basic auth") ], now: NOW)
+      assert Hive::Markers.current(state_file).none?
+      File.write(state_file, "# task\n\n<!-- ERROR reason=implementer_failed marker_id=err-a message=\"401 Missing bearer/basic auth\" -->\n")
+
+      # Attempt 2 (after backoff)
+      healer.heal([ make_row(state_file, reason: "implementer_failed", message: "401 Missing bearer/basic auth") ], now: NOW + 1800)
+      assert Hive::Markers.current(state_file).none?
+      File.write(state_file, "# task\n\n<!-- ERROR reason=implementer_failed marker_id=err-a message=\"401 Missing bearer/basic auth\" -->\n")
+
+      # Attempt 3 → exhausted
+      healer.heal([ make_row(state_file, reason: "implementer_failed", message: "401 Missing bearer/basic auth") ], now: NOW + 3600)
+
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file),
+                   "the 3rd failure must park the marker for manual recovery")
+      assert_equal 2, @logger.events.count { |name, _| name == :marker_healed }
+      exhausted = @logger.events.find { |name, _| name == :marker_heal_exhausted }
+      assert exhausted
+      assert_equal "codex_auth_recovered", exhausted[1][:reason]
+      assert_equal 2, exhausted[1][:attempts]
+      assert_equal 2, exhausted[1][:max_attempts]
+      assert_equal "per_process", exhausted[1][:budget_scope]
+      assert_match(/hive markers clear/, exhausted[1][:remediation])
+    end
+  end
+
+  def test_second_retry_within_backoff_is_throttled_as_unchanged_signal
+    cache = Hive::Daemon::HealthSignalCache.new
+    healer = build_healer(signal_cache: cache)
+    with_marker_file(reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") do |state_file, _dir|
+      healer.heal([ make_row(state_file, reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") ], now: NOW)
+      assert Hive::Markers.current(state_file).none?
+      File.write(state_file, "# task\n\n<!-- ERROR reason=claude_launch_failed marker_id=err-a message=\"claude interactive prompt did not become ready\" -->\n")
+
+      # Mirror the dispatcher's per-tick memo clear so this exercises the
+      # production path, not the in-process memo short-circuit.
+      cache.clear
+      # Same fingerprint, 10s later — within the 30 min backoff AND the
+      # fallback window, so the production path throttles as "signal
+      # unchanged" (the "backoff" rationale is unreachable in the
+      # unchanged-signal case).
+      healer.heal([ make_row(state_file, reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") ], now: NOW + 10)
+
+      assert_match(/ERROR reason=claude_launch_failed/, File.read(state_file),
+                   "a second retry within backoff must stay parked")
+      assert_equal 1, @logger.events.count { |name, _| name == :marker_healed }
+      blocked = @logger.events.select { |name, _| name == :auto_retry_blocked }
+      assert blocked.any? { |_, attrs| attrs[:rationale] == "signal unchanged" },
+             "the unchanged-signal case must throttle as 'signal unchanged', got: #{@logger.events.inspect}"
+      refute blocked.any? { |_, attrs| attrs[:rationale] == "backoff" },
+             "the 'backoff' rationale must not fire in the unchanged-signal case"
+    end
+  end
+
+  def test_changed_signal_within_backoff_allows_immediate_retry
+    # A changed health signal (the operator fixed the dependency) must
+    # bypass the 30-min backoff and allow the second retry immediately.
+    cfg = [ { "claude" => { "mode" => "headless" } } ]
+    resolver = ->(_name) { [ cfg[0], nil ] }
+    cache = Hive::Daemon::HealthSignalCache.new
+    healer = build_healer(project_config_resolver: resolver, signal_cache: cache)
+    with_marker_file(reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") do |state_file, _dir|
+      healer.heal([ make_row(state_file, reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") ], now: NOW)
+      assert Hive::Markers.current(state_file).none?
+      File.write(state_file, "# task\n\n<!-- ERROR reason=claude_launch_failed marker_id=err-a message=\"claude interactive prompt did not become ready\" -->\n")
+
+      # The operator fixes the dependency: the config slice changes, so the
+      # health fingerprint changes. 10s later is still within the 30-min
+      # backoff, but a changed signal must be retried immediately. Clear the
+      # per-tick memo first to mirror the dispatcher's `@signal_cache.clear`
+      # so the fingerprint is recomputed (and the change detected).
+      cfg[0] = { "claude" => { "mode" => "headless" }, "plan" => { "agent" => "claude" } }
+      cache.clear
+      healer.heal([ make_row(state_file, reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") ], now: NOW + 10)
+
+      assert Hive::Markers.current(state_file).none?,
+             "a changed health signal within backoff must allow the second retry"
+      assert_equal 2, @logger.events.count { |name, _| name == :marker_healed }
+    end
+  end
+
+  # ── unchanged-signal throttle / rescues ──────────────────────────────
+
+  def test_unchanged_signal_within_fallback_is_throttled
+    cache = Hive::Daemon::HealthSignalCache.new
+    healer = build_healer(signal_cache: cache)
+    with_marker_file(reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") do |state_file, _dir|
+      healer.heal([ make_row(state_file, reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") ], now: NOW)
+      assert Hive::Markers.current(state_file).none?
+      File.write(state_file, "# task\n\n<!-- ERROR reason=claude_launch_failed marker_id=err-a message=\"claude interactive prompt did not become ready\" -->\n")
+
+      # Simulate the next daemon tick: clear the per-tick memo, but keep the
+      # retry state (same fingerprint, no fallback elapsed).
+      cache.clear
+      healer.heal([ make_row(state_file, reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") ], now: NOW)
+
+      assert_match(/ERROR reason=claude_launch_failed/, File.read(state_file))
+      blocked = @logger.events.find { |name, attrs| name == :auto_retry_blocked && attrs[:rationale] == "signal unchanged" }
+      assert blocked, "an unchanged signal within the fallback window must throttle, got: #{@logger.events.inspect}"
+    end
+  end
+
+  def test_fingerprint_computed_once_per_tick_for_shared_reason_project
+    fingerprint_calls = 0
+    original = Hive::Daemon::HealthSignals.method(:fingerprint)
+    with_replaced_singleton_method(Hive::Daemon::HealthSignals, :fingerprint,
+                                   ->(**kwargs) { fingerprint_calls += 1; original.call(**kwargs) }) do
+      with_marker_file(reason: "claude_launch_failed", message: "claude interactive prompt did not become ready") do |state_file, dir|
+        row1 = make_row(state_file, reason: "claude_launch_failed", message: "claude interactive prompt did not become ready")
+        row2 = make_row(File.join(dir, "other.md"), reason: "claude_launch_failed", message: "claude interactive prompt did not become ready", marker_id: "err-b")
+        build_healer.heal([ row1, row2 ], now: NOW)
+
+        assert_equal 1, fingerprint_calls,
+                     "the health fingerprint must be computed once per (reason, project) per tick"
+      end
+    end
+  end
+
+  def test_probe_path_logs_marker_heal_failed_when_clear_raises
+    healer = build_healer
+    with_marker_file(reason: "implementer_failed", message: "401 Missing bearer/basic auth") do |state_file, _dir|
+      original = Hive::Markers.method(:clear_current)
+      Hive::Markers.define_singleton_method(:clear_current) do |path, *args|
+        raise Errno::ENOSPC, "no space left" if path == state_file
+
+        original.call(path, *args)
+      end
+
+      begin
+        healer.heal([ make_row(state_file, reason: "implementer_failed", message: "401 Missing bearer/basic auth") ], now: NOW)
+      ensure
+        Hive::Markers.define_singleton_method(:clear_current, &original)
+      end
+
+      failure = @logger.events.find { |name, _| name == :marker_heal_failed }
+      assert failure, "expected marker_heal_failed, got: #{@logger.events.inspect}"
+      assert_equal "codex_auth_recovered", failure[1][:reason]
+      assert_match(/ENOSPC/, failure[1][:error])
+    end
+  end
+
+  def test_resolve_project_config_default_paths
+    healer = build_healer(project_config_resolver: nil)
+    with_replaced_singleton_method(Hive::Config, :find_project, ->(_name) { nil }) do
+      assert_equal [ nil, nil ], healer.send(:resolve_project_config, "unknown")
+    end
+
+    entry = { "path" => "/tmp/proj" }
+    with_replaced_singleton_method(Hive::Config, :find_project, ->(_name) { entry }) do
+      with_replaced_singleton_method(Hive::Config, :load, ->(_path) { { "daemon" => {} } }) do
+        assert_equal [ { "daemon" => {} }, "/tmp/proj" ], healer.send(:resolve_project_config, "p")
+      end
+    end
+
+    with_replaced_singleton_method(Hive::Config, :find_project, ->(_name) { raise Hive::ConfigError, "boom" }) do
+      assert_equal [ nil, nil ], healer.send(:resolve_project_config, "p")
+    end
+  end
+
+  def test_worktree_clean_rescues_git_failure
+    with_tmp_git_repo do |repo|
+      Dir.mktmpdir do |folder_dir|
+        File.write(File.join(folder_dir, "worktree.yml"), { "path" => repo }.to_yaml)
+        row = make_row(File.join(folder_dir, "task.md"), reason: "claude_launch_failed", message: "x", folder: folder_dir)
+        healer = build_healer(worktree_clean: :real)
+        with_replaced_singleton_method(Open3, :capture3, ->(*_args) { raise Errno::EIO, "boom" }) do
+          refute healer.send(:worktree_clean?, row)
+        end
+      end
+    end
+  end
+
+  def test_worktree_path_for_rescues_pointer_error
+    healer = build_healer(worktree_clean: :real)
+    row = make_row("/tmp/task.md", reason: "claude_launch_failed", message: "x")
+    with_replaced_singleton_method(Hive::Worktree, :read_pointer, ->(_folder) { raise Errno::EACCES, "nope" }) do
+      assert_nil healer.send(:worktree_path_for, row)
+    end
+  end
+
+  # ── kill-switch ────────────────────────────────────────────────────────
+
+  def test_kill_switch_disables_probe_retry
+    @healer_off = Hive::Daemon::StaleAgentHealer.new(
+      controller: @controller, logger: @logger, grace_sec: 300,
+      request_queue: @request_queue, probe: @probe, auto_retry_enabled: false,
+      project_config_resolver: ->(_name) { [ HEADLESS_CFG, nil ] }
+    )
+    with_marker_file(reason: "implementer_failed", message: "401 Missing bearer/basic auth") do |state_file, _dir|
+      row = make_row(state_file, reason: "implementer_failed", message: "401 Missing bearer/basic auth")
+      @healer_off.heal([ row ], now: NOW)
+
+      refute @logger.events.any? { |name, _| name == :marker_healed }
+      assert_empty @probe.calls, "kill-switch off must skip the probe path entirely"
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+    end
+  end
+end
